-- Copyright (c) 2024 - Ognjen 'xolatile' Milan Robovic
--
-- GNU General Public Licence (version 3 or later)

with core, ui, attribute;

package body attribute is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	sprite : array (enumeration) of core.sprite;

                                             ------------------------------------------------------------------------------------------

	procedure configure is
	begin
		core.echo (core.comment, "Configuring attribute components...");
		--
		for index in enumeration
		loop
			sprite (index) := core.import_sprite ("./sprite/attribute/" & core.lowercase (enumeration'image (index)) & ".png", 1, 1);
		end loop;
	end configure;

                                             ------------------------------------------------------------------------------------------

	procedure menu (x, y : in integer; center : in boolean) is
		offset : constant integer := 16;
		width  : constant integer := 180 + 2 * offset;
		height : constant integer := count * core.icon + 2 * offset;
		move_x : constant integer := (if center then (core.window_width  - width)  / 2 else x);
		move_y : constant integer := (if center then (core.window_height - height) / 2 else y);
	begin
		ui.draw_tiny_menu (move_x, move_y, width, height, true);
		ui.draw_title_bar (move_x, move_y, width, "Attributes");
		--
		for index in enumeration
		loop
			ui.draw_icon (sprite (index), trait (index).text, move_x + offset,             move_y + offset + enumeration'pos (index) * core.icon);
			ui.write     (trait (index).name, move_x + offset + core.icon, move_y + offset + enumeration'pos (index) * core.icon);
		end loop;
	end menu;

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end attribute;
