-- Copyright (c) 2024 - Ognjen 'xolatile' Milan Robovic
--
-- GNU General Public Licence (version 3 or later)

with core;

package attribute is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	type enumeration is (
		offense,                defense,                wisdom,                 stamina,                speed,                  reach
	);

                                             ------------------------------------------------------------------------------------------

	subtype base_limit is natural range 0 .. 12;

	type information is
	record
		name : core.short_string;
		base : base_limit;
		text : core.long_string;
	end record;

	type points is array (enumeration) of base_limit;

                                             ------------------------------------------------------------------------------------------

	count : constant natural := enumeration'pos (enumeration'last) + 1;

	trait : constant array (enumeration) of information := (
		("Offense                 ", 0, "-                                                                       "),
		("Defense                 ", 0, "-                                                                       "),
		("Wisdom                  ", 0, "-                                                                       "),
		("Stamina                 ", 0, "-                                                                       "),
		("Speed                   ", 0, "-                                                                       "),
		("Reach                   ", 0, "-                                                                       ")
	);

                                             ------------------------------------------------------------------------------------------

	procedure configure;

	procedure menu (x, y : in integer; center : in boolean);

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end attribute;
