-- Copyright (c) 2024 - Ognjen 'xolatile' Milan Robovic
--
-- GNU General Public Licence (version 3 or later)

with core, effect, resource, faction;

package construction is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	type enumeration is (
		a, b, c, d, e, f
	);

                                             ------------------------------------------------------------------------------------------

	type information is
	record
		name   : core.short_string;
		kind   : faction.enumeration;
		price  : resource.points;
		frames : integer;
		evoke  : effect.enumeration;
	end record;

                                             ------------------------------------------------------------------------------------------

	count : constant natural := enumeration'pos (enumeration'last) + 1;

	trait : constant array (enumeration) of information := (
		("A                       ", faction.dwarf,  (others => 0), 1, effect.none),
		("B                       ", faction.fairy,  (others => 0), 1, effect.none),
		("C                       ", faction.gnoll,  (others => 0), 1, effect.none),
		("D                       ", faction.goblin, (others => 0), 1, effect.none),
		("E                       ", faction.imp,    (others => 0), 1, effect.none),
		("F                       ", faction.kobold, (others => 0), 1, effect.none)
	);

                                             ------------------------------------------------------------------------------------------

	procedure configure;

	procedure draw (index : in enumeration; x, y : in integer);

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end construction;
