-- Copyright (c) 2024 - Ognjen 'xolatile' Milan Robovic
--
-- GNU General Public Licence (version 3 or later)

with core;

package deity is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	type enumeration is (
		svarog,                 dabog,                  svetovid,               gozag,                  ru,                     xom,
		sheigarath,             ornhul,                 khuganagoth,            vel_sheina,             deigehen,               geazhul
	);

                                             ------------------------------------------------------------------------------------------

	subtype piety_limit is integer range -30 .. 30;

	type information is
	record
		name : core.short_string;
		base : piety_limit;
	end record;

                                             ------------------------------------------------------------------------------------------

	count : constant natural := enumeration'pos (enumeration'last) + 1;

	trait : constant array (enumeration) of information := (
		("Svarog the Lawful       ",  3), -- Serbia
		("Dabog the Lonely        ", -3),
		("Svetovid the Awakened   ",  0),
		("Gozag the Impoverished  ",  0), -- DCSS
		("Ru the Forgotten        ", -3),
		("Xom the Chaotical       ",  3),
		("Sheigarath the Dark     ", -3), -- Gea
		("Ornhul the Frozen       ",  0),
		("Khuganagoth the Hungry  ", -3),
		("Vel-Sheina the Joyful   ",  3),
		("Deigehen the Chained    ",  0),
		("Geazhul the Awakened    ",  3)
	);

                                             ------------------------------------------------------------------------------------------

	procedure draw (value : in enumeration; x, y : in integer);

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end deity;
