-- Copyright (c) 2024 - Ognjen 'xolatile' Milan Robovic
--
-- GNU General Public Licence (version 3 or later)

with core, item;

package body item is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	sprite : array (enumeration) of core.sprite;

                                             ------------------------------------------------------------------------------------------

	procedure configure is
	begin
		core.echo (core.comment, "Configuring item components...");
		--
		for index in enumeration
		loop
			declare
				folder : constant string := core.lowercase (slot'image (trait (index).kind));
				file   : constant string := core.lowercase (enumeration'image (index));
			begin
				sprite (index) := core.import_sprite ("./sprite/item/" & folder & "/" & file & ".png", 1, 1);
			end;
		end loop;
	end configure;

                                             ------------------------------------------------------------------------------------------

	procedure draw (index : in enumeration; x, y : in integer) is
	begin
		core.draw (sprite (index), x, y);
	end draw;

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end item;
