-- Copyright (c) 2024 - Ognjen 'xolatile' Milan Robovic
--
-- GNU General Public Licence (version 3 or later)

with core;

package resource is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	type enumeration is (
		gold,                   wood,                   stone,                  steel,                  leather,                crystal
	);

                                             ------------------------------------------------------------------------------------------

	subtype base_limit is natural range 0 .. 144000;

	type information is
	record
		name : core.short_string;
		base : base_limit;
		text : core.long_string;
	end record;

	type points is array (enumeration) of base_limit;

                                             ------------------------------------------------------------------------------------------

	count : constant natural := enumeration'pos (enumeration'last) + 1;

	trait : constant array (enumeration) of information := (
		("Gold                    ", 0, "-                                                                       "),
		("Wood                    ", 0, "-                                                                       "),
		("Stone                   ", 0, "-                                                                       "),
		("Steel                   ", 0, "-                                                                       "),
		("Leather                 ", 0, "-                                                                       "),
		("Crystal                 ", 0, "-                                                                       ")
	);

                                             ------------------------------------------------------------------------------------------

	procedure configure;

	procedure menu (x, y : in integer; center : in boolean);

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end resource;
