-- Copyright (c) 2024 - Ognjen 'xolatile' Milan Robovic
--
-- GNU General Public Licence (version 3 or later)

with core;

package skill is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	type enumeration is (
		archery,                diplomacy,              estates,                exploration,            leadership,             logistics,
		medicine,               mercantile,             mysticism,              necromancy,             sorcery,                tactics
	);

                                             ------------------------------------------------------------------------------------------

	subtype base_limit is natural range 0 .. 36;

	type information is
	record
		name : core.short_string;
		base : base_limit;
		text : core.long_string;
	end record;

	type points is array (enumeration) of base_limit;

                                             ------------------------------------------------------------------------------------------

	count : constant natural := enumeration'pos (enumeration'last) + 1;

	trait : constant array (enumeration) of information := (
		("Archery                 ", 0, "-                                                                       "),
		("Diplomacy               ", 0, "-                                                                       "),
		("Estates                 ", 0, "-                                                                       "),
		("Exploration             ", 0, "-                                                                       "),
		("Leadership              ", 0, "-                                                                       "),
		("Logistics               ", 0, "-                                                                       "),
		("Medicine                ", 0, "-                                                                       "),
		("Mercantile              ", 0, "-                                                                       "),
		("Mysticism               ", 0, "-                                                                       "),
		("Necromancy              ", 0, "-                                                                       "),
		("Sorcery                 ", 0, "-                                                                       "),
		("Tactics                 ", 0, "-                                                                       ")
	);

                                             ------------------------------------------------------------------------------------------

	procedure configure;

	procedure menu (x, y : in integer; center : in boolean);

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end skill;
